Attribute VB_Name = "mdlDirectSound"
Option Explicit

Public DX8 As DirectX8
Public DXS As DirectSound8
Public DXSB As DirectSoundSecondaryBuffer8
Public DXC As DirectSoundCapture8
Public DXCB As DirectSoundCaptureBuffer8
Public bufferDesc As DSBUFFERDESC
Public cbufferDesc As DSCBUFFERDESC
Public EventStop As Long
Public EventNotify As Long

Public Format As String

Public Sub LoadDX()
Set DX8 = New DirectX8


'__________________________________sound buffer_______________________________


Set DXS = DX8.DirectSoundCreate(vbNullString)
DXS.SetCooperativeLevel frmMain.hWnd, DSSCL_PRIORITY
With bufferDesc
    With .fxFormat
        .lExtra = 0
        .lSamplesPerSec = IIf(InStr(1, Format, "44.100 kHz,") > 0, 44100, IIf(InStr(1, Format, "22.050 kHz,") > 0, 22050, 11025))
        .nBitsPerSample = IIf(InStr(1, Format, ",16-bit") > 0, 16, 8)
        .nChannels = IIf(InStr(1, Format, "stereo") > 0, 2, 1)
        .nFormatTag = WAVE_FORMAT_PCM
        '.nSize = LenB(bufferDesc)
        .nBlockAlign = .nBitsPerSample / 8 * .nChannels
        .lAvgBytesPerSec = .lSamplesPerSec * .nBlockAlign
    End With
    .guid3DAlgorithm = GUID_DS3DALG_DEFAULT
    .lBufferBytes = .fxFormat.lAvgBytesPerSec * 5
    .lFlags = DSBCAPS_CTRLFREQUENCY Or DSBCAPS_CTRLPAN Or DSBCAPS_CTRLVOLUME Or DSBCAPS_STATIC
End With
Set DXSB = DXS.CreateSoundBuffer(bufferDesc)


'_________________________________capture buffer_______________________________


Set DXC = DX8.DirectSoundCaptureCreate(vbNullString)
With cbufferDesc
    With .fxFormat
        .lSamplesPerSec = IIf(InStr(1, Format, "44.100 kHz,") > 0, 44100, IIf(InStr(1, Format, "22.050 kHz,") > 0, 22050, 11025))
        .nBitsPerSample = IIf(InStr(1, Format, ",16-bit") > 0, 16, 8)
        .nChannels = IIf(InStr(1, Format, "stereo") > 0, 2, 1)
        .nFormatTag = WAVE_FORMAT_PCM
        .nSize = 0
        .nBlockAlign = .nBitsPerSample / 8 * .nChannels
        .lAvgBytesPerSec = .lSamplesPerSec * .nBlockAlign
    End With
    .lBufferBytes = .fxFormat.lAvgBytesPerSec * 5
    .lFlags = DSCBCAPS_DEFAULT
End With
Set DXCB = DXC.CreateCaptureBuffer(cbufferDesc)
End Sub

Public Sub UnloadDX()
Set DXSB = Nothing
Set DXS = Nothing
Set DXCB = Nothing
Set DXC = Nothing
Set DX8 = Nothing
End Sub
